<script>
  // Dimensions
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

export let data=[];

import { scaleLinear } from 'd3-scale';
import { scaleOrdinal } from 'd3-scale';
import { extent } from 'd3-array';
import { schemeDark2 } from 'd3-scale-chromatic';
import { axisBottom, axisLeft } from 'd3-axis'; 
import { select } from 'd3-selection';


const scaleX=scaleLinear().domain(extent(data.map(function (item) {
  return(item.income);
}))).range([0, 545]);

const scaleY=scaleLinear().domain(extent(data.map(function (item) {
  return(item.life_exp);
}))).range([innerHeight, 0]);

const scaleC=scaleOrdinal().domain(extent(data.map(function (item) {
  return(item.continent);
}))).range([schemeDark2]); 

const axisX= axisBottom(scaleX);
const axisY=axisLeft(scaleY);

function xAxis(g) {
  axisX(select(g))
};

function yAxis(g){
  axisY(select(g))
};

</script>

<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left}, {margin.top})">
    {#each data as i}
      <circle cx={scaleX(i.income)} cy={scaleY(i.life_exp)} r="5" style={"fill:" +scaleC(i.continent)}/>
   {/each}
  </g>
  <g transform="translate({margin.left}, {height-margin.bottom})" use:xAxis></g>
  <g transform="translate({margin.left}, {margin.top})" use:yAxis></g>
  <g transform="translate({margin.left}, {margin.top}) rotate(270)" fill="none" font-size="15" font-family="sans-serif" text-anchor="middle">
    <text x="-130" y="-30" fill="currentcolor">Life expectancy</text>
  </g>
  <g transform="translate({margin.left}, {margin.top})" fill="none" font-size="15" font-family="sans-serif" text-anchor="middle">
    <text x={innerWidth/2} y={height-margin.bottom} fill="currentcolor">GDP per capita</text>
  </g>
  <g transform="translate({margin.left}, {margin.top})" fill="none" font-size="30" font-family="sans-serif" text-anchor="middle">
    <text x={innerWidth/2} y="0" fill="currentcolor">Gapminder scatterplot</text>
  </g>
</svg>

